local playerManager_module = require("modules/game/playerManager")
local meleeManager_module = require("modules/game/meleeManager")
local projectileManager_module = require("modules/game/projectileManager")
local sound_module = require("modules/sound/sound")

return {
	["new"] = function(_, _, values, vars)
		if values[1] == "range" then
			vars["ammo"] = tonumber(values[6])
			vars["auto"] = values[7] == "true" and true or false
		end
	end,
	["use"] = function()
		return 1, 0, 2
	end,
	["equip"] = function(itemEntry, playerID, values, vars)
		local direction = playerManager_module.getDirection(playerID)
		if values[1] == "melee" then
			sound_module.soundEffectsHelper("meleeShoot", 7, 14)
			meleeManager_module.new(playerID, itemEntry, direction)
			return 1, 0, values[3] + values[4]
		elseif values[1] == "range" then
			if vars["ammo"] > 0 then
				sound_module.soundEffectsHelper("shoot", 7, 14)
				projectileManager_module.new(playerID, itemEntry, direction)
				vars["ammo"] = vars["ammo"] - 1
				return 1, 0, values[3]
			end
		end
	end,
	["equipHold"] = function(itemEntry, playerID, values, vars)
		if vars["auto"] then -- only happens to range weapons
			if vars["ammo"] > 0 then
				sound_module.soundEffectsHelper("shoot", 7, 14)
				local direction = playerManager_module.getDirection(playerID)
				projectileManager_module.new(playerID, itemEntry, direction)
				vars["ammo"] = vars["ammo"] - 1
				return 1, 0, values[3]
			end
		end
	end
}