local card_module = {}

local u_createQuads = require("modules/utils/createQuads")

local BOUNCE_LIMIT = 5
local TERMINAL_VEL = 15.0
local STARTING_POS = -(16 * 11)
local FALL_SPEED = 0.58

local endCard = love.graphics.newImage("res/endScreen.png")
local endCardQuads = u_createQuads(16 * 16, 16 * 11, endCard:getDimensions())
local cardSel = 1
local update = false
local pos = STARTING_POS
local vel = 0
local bounceCount = 0

function card_module.update()
	if update then
		vel = math.min(vel + FALL_SPEED, TERMINAL_VEL)
		pos = pos + vel
		if pos >= 0 then
			if bounceCount >= BOUNCE_LIMIT then
				pos = 0
				update = false
			else
				vel = -vel / 2
				pos = vel
				bounceCount = bounceCount + 1
			end
		end
	end
end

function card_module.render()
	love.graphics.draw(endCard, endCardQuads[cardSel], 0, pos)
end

function card_module.reset()
	update = false
	pos = STARTING_POS
	vel = 0
	bounceCount = 0
end

function card_module.start()
	update = true
end

function card_module.selectCard(val)
	cardSel = val
end

function card_module.hasFinished()
	return bounceCount >= BOUNCE_LIMIT
end

function card_module.getCardSel()
	return cardSel
end

return card_module