local spritePool_module = {}

local sprites = {}
local spriteFilePath = {}
sprites[0] = love.graphics.newImage(love.image.newImageData(16, 16))

function spritePool_module.load(filePath)
	-- check if the sprite is already loaded
	for i = 1, #sprites do
		if spriteFilePath[i] == filePath then
			return i
		end
	end
	-- load the sprite
	local imageData = love.graphics.newImage(filePath)
	sprites[#sprites + 1] = imageData
	spriteFilePath[#spriteFilePath + 1] = filePath
	return #sprites
end

function spritePool_module.get(id)
	return sprites[id]
end

function spritePool_module.getDimensions(id)
	return sprites[id]:getDimensions()
end

function spritePool_module.unload(id)
	if id == 0 then
		return
	end
	sprites[id]:release()
	sprites[id] = nil
	spriteFilePath[id] = nil
end

return spritePool_module