local keyboard_module = {}

local keyArray = {}
-- layout: num = {key, state}
-- states: 0 = not pressed 1 = pressed 2 = held 3 = released

function keyboard_module.update()
	for _, i in pairs(keyArray) do
		local isDown = love.keyboard.isDown(i[1])
		if i[2] == 0 then
			if isDown then
				i[2] = 1
			end
		elseif i[2] == 1 then
			if isDown then
				i[2] = 2
			else
				i[2] = 3
			end
		elseif i[2] == 2 then
			if not isDown then
				i[2] = 3
			end
		elseif i[2] == 3 then
			if isDown then
				i[2] = 1
			else
				i[2] = 0
			end
		end
	end
end

function keyboard_module.setKey(id, key)
	if id == 0 then return end
	keyArray[id] = {key, 0}
end

function keyboard_module.getKey(id)
	if id == 0 then return end
	return keyArray[id][2]
end

function keyboard_module.isDown(id)
	if id == 0 then return end
	return keyArray[id][2] == 1 or keyArray[id][2] == 2
end

function keyboard_module.isPressed(id)
	if id == 0 then return end
	return keyArray[id][2] == 1
end

return keyboard_module