return function(folderDir, fileExt, ident, processFunction, includeFolders)
	local loadedFiles = {}
	local files = love.filesystem.getDirectoryItems(folderDir)
	local fileExtPattern = "%."..fileExt.."$"
	local useFunction = processFunction or require
	for i = 1, #files do
		local fileExtStart = string.find(files[i], fileExtPattern)
		local name = nil
		if fileExtStart then
			name = string.sub(files[i], 1, fileExtStart - 1)
		elseif includeFolders and love.filesystem.getInfo(folderDir.."/"..files[i], "directory") then
			name = files[i]
		end
		local res = useFunction(folderDir.."/"..name, name)
		if res then
			loadedFiles[name] = res
			print("Loaded "..ident.." - "..name)
		else
			print("Failed to load "..ident.." - "..name)
		end
	end
	print("All "..ident.."s loaded")
	return loadedFiles
end