// layer uniforms
extern Image self;
extern Image stencil;
extern float layer;
// tint uniform
extern vec3 tint;
// flip uniforms
extern bool flipH;
extern bool flipV;
extern vec2 texSize;
extern vec4 viewPort;
// mode uniform
extern bool mode; // true: render mode false: stencil mode
vec4 effect(vec4 color, Image texture, vec2 texture_coords, vec2 screen_coords) {
	// bit shifts are not supported
	if (flipH)
		texture_coords.x = (viewPort[0] * 2 + viewPort[2]) / texSize[0] - texture_coords.x;
	if (flipV)
		texture_coords.y = (viewPort[1] * 2 + viewPort[3]) / texSize[1] - texture_coords.y;
	vec4 texturecolor = Texel(texture, texture_coords);
	if (mode) {
		vec2 scrttc = screen_coords / love_ScreenSize.xy;
		float selfAlpha = Texel(self, scrttc).a;
		float stencilVal = Texel(stencil, scrttc).r;
		if (texturecolor.a == 0.0 || (layer < stencilVal && selfAlpha == 1.0)) {
			discard;
		} else if (texturecolor.a == 1.0) {
			return (texturecolor + vec4(tint, 0.0)) * color;
		}
		return vec4(1, 0, 1, 1);
	} else {
		if (texturecolor.a == 0.0)
			discard;
		return vec4(layer, 0, 0, 1);
	}
}