// layer uniforms
extern Image self;
extern Image stencil;
extern float layer;
// tint uniform
extern vec3 tint;
// flip uniforms
extern bool flipH;
extern bool flipV;
extern vec2 texSize;
extern vec4 viewPort;
// muti canvas shader stuff
extern Image MainTex;
void effect() {
	// bit shifts are not supported
	vec2 texCoord = VaryingTexCoord.xy;
	if (flipH)
		texCoord.x = (viewPort[0] * 2 + viewPort[2]) / texSize[0] - texCoord.x;
	if (flipV)
		texCoord.y = (viewPort[1] * 2 + viewPort[3]) / texSize[1] - texCoord.y;
	vec4 texturecolor = Texel(MainTex, texCoord);
	vec2 scrttc = love_PixelCoord / love_ScreenSize.xy;
	vec4 selfTex = Texel(self, scrttc);
	float stencilVal = Texel(stencil, scrttc).r;
	// stencil
	if (texturecolor.a == 0.0) {
		love_Canvases[0] = vec4(stencilVal, 0, 0, 1);
	} else {
		love_Canvases[0].r = max(stencilVal, layer);
		//love_Canvases[0] = vec4(layer, 0, 0, 1);
	}
	// render
	if (texturecolor.a == 0.0 || (layer < stencilVal && selfTex.a == 1.0)) {
		love_Canvases[1] = selfTex;
	} else if (texturecolor.a == 1.0) {
		love_Canvases[1] = (texturecolor + vec4(tint, 0.0)) * VaryingColor;
	} else {
		love_Canvases[1] = vec4(1, 0, 1, 1);
	}
}